{$D+}
PROGRAM DictM2;

{$DEFINE DisableUTF8RTL}
{$DEFINE DOSFPC}

{$IFDEF DOS} {$M 65520,0,655360} {$N+}
{$ELSE} {$mode objfpc} {$H-}
        {$IFDEF X86_64} {$MAXSTACKSIZE $7FFFFFF} {$ENDIF}
{$ENDIF}

USES Dict20, StdIO, Strings, DOS,
     {$IFDEF X86_64} Zeit, SysUtils
     {$ELSE} Zeit19
     {$ENDIF} ;

CONST VERSION_INFO = 'LISTE   Testprogramm   V 0.11 ' +
{$IFDEF DOS} '(16bit)' {$ELSE} {$IFDEF X86_64} '(64bit)' {$ELSE} '(32bit)' {$ENDIF}
{$ENDIF} + ' 06.03.2020   (c) ALFWARE B.Schubert';

CONST maximal   : LONGINT = 100;
      anzahl    : LONGINT = 0;

PROCEDURE SPIEL;
VAR kette, ergebnis: S_SCHLUESSEL;
    eingabe: CHAR;
    i: INTEGER;
BEGIN
   anzahl:=0; eingabe:='X';
   WHILE (eingabe <> '0') DO BEGIN
      INC(anzahl);
      kette:=''; FOR i:=1 TO RANDOM(10)+1 DO kette:=kette+CHR(ORD('0')+RANDOM(10));
      ergebnis:=StrCardInt(anzahl);
      WriteLn('Die Kette ist: ',kette);
      REPEAT
         Write('Gib die Funktion ein: 1=Add 2=Delete 3=Find 4=Clear 5=FindValue, 0=Ende : ');
         eingabe:=Taste0;
         WriteLN;
      UNTIL eingabe IN ['0'..'5'];
      CASE eingabe OF
        '1': Dict_SS_Add(0, kette, ergebnis);
        '2': IF Dict_SS_Delete(0, kette)
                THEN WriteLn('Key: ', kette, ' GELSCHT!')
                ELSE WriteLn('Key: ', kette, ' NICHT GELSCHT!');
        '3': IF Dict_SS_Find(0, kette, ergebnis)
                THEN WriteLn('Key: ', kette, ' Value: ', ergebnis)
                ELSE WriteLn('Key: ', kette, ' NICHT GEFUNDEN!');
        '4': Dict_SS_Clear(0);
        '5': IF Dict_SS_FindValue(0, kette, ergebnis)
                THEN WriteLn('Value: ', kette, ' Key: ', ergebnis)
                ELSE WriteLn('Value: ', kette, ' NICHT GEFUNDEN!');
        ELSE
      END;
      WriteLn('Anzahl Eintrge: ',Dict_SS_Count(0));
      Writeln('Liste:'); Dict_SS_Liste(0);
      Heap_Info;
   END;
END;

BEGIN
   {$IFNDEF DOS} DefaultSystemCodePage:=TextRec(Output).CodePage; {$ENDIF}
   WriteLn('Anfang: '+ Intervall_Start(1));
   {$IFNDEF DOS} ReturnNilIfGrowHeapFails:=TRUE; {$ENDIF}
   Heap_Info;
   SPIEL;
   Dict_II_Clear(0);
   Dict_SS_Clear(0);
   Heap_Info;
   WriteLn('Ende: '+ Intervall_Stop(1) + ', ' + Intervall_Dauer(1));
END (* DictM2 *).
