{$D+}
PROGRAM DictM1;

{$DEFINE DisableUTF8RTL}
{$DEFINE DOSFPC}

{$IFDEF DOS} {$M 65520,0,655360} {$N+}
{$ELSE} {$mode objfpc} {$H-}
        {$IFDEF X86_64} {$MAXSTACKSIZE $7FFFFFF} {$ENDIF}
{$ENDIF}

USES Dict20, StdIO, Strings, DOS,
     {$IFDEF X86_64} Zeit, SysUtils
     {$ELSE} Zeit19
     {$ENDIF} ;

CONST VERSION_INFO = 'LISTE   Testprogramm   V 0.11 ' +
{$IFDEF DOS} '(16bit)' {$ELSE} {$IFDEF X86_64} '(64bit)' {$ELSE} '(32bit)' {$ENDIF}
{$ENDIF} + ' 06.03.2020   (c) ALFWARE B.Schubert';

CONST maximal   : LONGINT = 100;
      anzahl    : LONGINT = 0;

PROCEDURE SPIEL;
VAR zahl, ergebnis: LONGINT;
    eingabe: CHAR;
BEGIN
   anzahl:=0; eingabe:='X';
   WHILE (eingabe <> '0') DO BEGIN
      INC(anzahl);
      zahl:=RANDOM(10)+1;
      WriteLn('Die Zahl ist: ',zahl);
      REPEAT
         Write('Gib die Funktion ein: 1=Add 2=Delete 3=Find 4=Clear 5=FindValue, 0=Ende : ');
         eingabe:=Taste0;
         WriteLN;
      UNTIL eingabe IN ['0'..'5'];
      CASE eingabe OF
        '1': Dict_Add(zahl, anzahl);
        '2': IF Dict_Delete(zahl)
                THEN WriteLn('Key: ', zahl, ' GELSCHT!')
                ELSE WriteLn('Key: ', zahl, ' NICHT GELSCHT!');
        '3': IF Dict_Find(zahl, ergebnis)
                THEN WriteLn('Key: ', zahl, ' Value: ', ergebnis)
                ELSE WriteLn('Key: ', zahl, ' NICHT GEFUNDEN!');
        '4': Dict_Clear;
        '5': IF Dict_FindValue(zahl, ergebnis)
                THEN WriteLn('Value: ', zahl, ' Key: ', ergebnis)
                ELSE WriteLn('Value: ', zahl, ' NICHT GEFUNDEN!');
        ELSE
      END;
      WriteLn('Anzahl Eintrge: ',Dict_count);
      Writeln('Liste:'); Dict_Liste;
      Heap_Info;
   END;
END;

BEGIN
   {$IFNDEF DOS} DefaultSystemCodePage:=TextRec(Output).CodePage; {$ENDIF}
   WriteLn('Anfang: '+ Intervall_Start(1));
   {$IFNDEF DOS} ReturnNilIfGrowHeapFails:=TRUE; {$ENDIF}
   Heap_Info;
   SPIEL;
   Dict_II_Clear(0);
   Heap_Info;
   WriteLn('Ende: '+ Intervall_Stop(1) + ', ' + Intervall_Dauer(1));
END (* DictM1 *).
